package cn.ibizlab.assetmanagement.core.asset.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.assetmanagement.core.asset.domain.EAMSparePartsPRO;
import cn.ibizlab.assetmanagement.core.asset.filter.EAMSparePartsPROSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EAMSparePartsPRO] 服务对象接口
 */
public interface IEAMSparePartsPROService extends IService<EAMSparePartsPRO>{

    boolean create(EAMSparePartsPRO et) ;
    void createBatch(List<EAMSparePartsPRO> list) ;
    boolean update(EAMSparePartsPRO et) ;
    void updateBatch(List<EAMSparePartsPRO> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EAMSparePartsPRO get(String key) ;
    EAMSparePartsPRO getDraft(EAMSparePartsPRO et) ;
    boolean checkKey(EAMSparePartsPRO et) ;
    boolean save(EAMSparePartsPRO et) ;
    void saveBatch(List<EAMSparePartsPRO> list) ;
    Page<EAMSparePartsPRO> searchDefault(EAMSparePartsPROSearchContext context) ;
    List<EAMSparePartsPRO> selectByProductid(String productid) ;
    void removeByProductid(String productid) ;
    List<EAMSparePartsPRO> selectByEamsparepartsgroupid(String eamsparepartsgroupid) ;
    void removeByEamsparepartsgroupid(String eamsparepartsgroupid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EAMSparePartsPRO> getEamsparepartsproByIds(List<String> ids) ;
    List<EAMSparePartsPRO> getEamsparepartsproByEntities(List<EAMSparePartsPRO> entities) ;
}


